﻿using UnityEngine;
using System.Collections;

public class ptlight1 : MonoBehaviour {
	private Light ptlight;
	float targettime;
	float timer;
	public float flashtime; // seconds

	// RTcmix/audio stuff
	private int objno = 0;
	private rtcmixmain RTcmix;
	int trigaudio;
	public getMyTransform localsrc; // to get position relative to 'observer'


	// Use this for initialization
	void Start () {
		ptlight = GetComponent<Light>();
		ptlight.intensity = 0.0f;
		ptlight.range = 0.0f;

		targettime = 1.0f;
		timer = 0.0f;
		if (flashtime == 0.0f) // in case it hasn't been set
			flashtime = 1.0f;

		// RTcmix stuff
		localsrc = GameObject.Find ("observer").GetComponent<getMyTransform> ();
		RTcmix = GameObject.Find ("RTcmixmain").GetComponent<rtcmixmain> ();
		RTcmix.initRTcmix (objno);

		// we do this because sometimes RTcmix doesn't get initialized completely here
		RTcmix.SendScore ("MAXBANG(0.5)", objno);
	}
	
	// Update is called once per frame
	void Update () {
		if (Time.time > targettime) {
			float glow = Mathf.PingPong (timer, 1.0f);
			ptlight.intensity = glow;
			ptlight.range = glow * 2.0f;

			// WAVETABLE(outsk, dur, AMP, PITCH[, PAN, WAVETABLE])
			// MOOGVCF(outsk, insk, dur, AMP, inputchan, PAN, BYPASS, FILTFREQTABLE, FILTRESONTABLE)
			if (trigaudio == 0) {
				// flashtime is doubled for rise & fall in Mathf.PingPong()
				RTcmix.SendScore ("WAVETABLE(0, " + flashtime*2.0f + ", 20000*ampenv, 8.02, 0.5, wave) " +
					"MOOGVCF(0, 0, " + flashtime*2.0f + ", 1, 0, 0.5, 0, cfreq, 0.9) ", objno);
				trigaudio = 1;
			}

			// if sound is happening, update the location
			// note the the Z and the Y axis get swapped because of the way Unity labels them
			if (RTcmix != null) {
				Vector3 srcpos = localsrc.getTransform (gameObject); // this source relative to the 'observer' object
				RTcmix.setpfieldRTcmix (1, srcpos.x, objno);
				RTcmix.setpfieldRTcmix (2, srcpos.z, objno);
			}

			timer += (Time.deltaTime * (1.0f / flashtime));
	
			if (timer > 2.0f) { // one ping-pong cycle complete
				targettime = Time.time + 0.5f;
				timer = 0.0f;
				trigaudio = 0;
			}
		}
	}

	void OnAudioFilterRead(float[] data, int channels) {
		RTcmix.runRTcmix (data, objno, 0);

		if (RTcmix.checkbangRTcmix (objno) == 1) {
			// note the the Z and the Y axis get swapped because of the way Unity labels them
			RTcmix.SendScore ("bus_config(\"WAVETABLE\", \"aux 0-1 out\") " +
				"bus_config(\"MOOGVCF\", \"aux 0-1 in\", \"aux 2-3 out\") " +
				"bus_config(\"LOCALIZE\", \"aux 2-3 in\", \"out 0-1\")  " +
				"ampenv = maketable(\"line\", 1000, 0,0, 1,1, 2,0) " +
				"cfreq = maketable(\"line\", \"nonorm\", 1000, 0,500, 1,1500, 2,500) " +
				"wave = maketable(\"wave\", 1000, \"saw\") " +
				"srcX = makeconnection(\"inlet\", 1, 1)  " +
				"srcZ = makeconnection(\"inlet\", 2, 5)  " +
				"LOCALIZE(0, 0, 9999, 1,  srcX, srcZ, 0,  0, 0, 0,  1, 1,  0,  1, 2)", objno);
		}
	}

	void OnApplicationQuit() {
		RTcmix.destroy (objno);
	}
}
